# ZPhotoSlides, Zope product
# Copyright (C) 2002-2003  Jean-Franois Roche <jfroche@jfroche.be>
#                          Florent Carlier <florent.carlier@insa-rennes.fr>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
# $Id: ZPhotoSlides.py,v 1.112 2003/09/24 13:33:54 fcarlier Exp $'

VERSION = '1.2'
DATE = '19/08/2003'

from Globals import HTMLFile      # fakes a method from a DTML file
from Globals import HTML
from Globals import package_home
from Globals import MessageDialog # provid
from OFS.Folder import Folder
from OFS.Image  import Image, cookId
from AccessControl.Role import RoleManager
from AccessControl import getSecurityManager
from AccessControl import User, Unauthorized
from Acquisition import aq_base
import AccessControl
from Persistence import Persistent
import OFS.SimpleItem
import Acquisition
import AccessControl.Role
import traceback
import os, sys
import math
from math import floor
import time
from DateTime import DateTime
import random
import string
import shutil
import comment
import postalcard
import rating
import re, whrandom
from stat import stat
import layout
# from Products.PageTemplates import ZopePageTemplate    # i should learn more about this...
from Products.LocalFS import LocalFS
from Products.MailHost import MailHost
from Products.PythonScripts import PythonScript
from Products.StandardCacheManagers import AcceleratedHTTPCacheManager
import ZPhotoSlidesUtils
from ZPSPloneBatch import Batch

try:
	from Products.CMFCore.CMFCorePermissions import View, ManageProperties, ListFolderContents
	from Products.CMFDefault.DublinCore import DefaultDublinCoreImpl
	from Products.CMFCore.PortalContent import PortalContent
	from Products.CMFCore import CMFCorePermissions
except:
	have_cmf = 0
	class CMFCorePermissions:
		def View(self):
			pass
		def ModifyPortalContent(self):
			pass
		
else:
	have_cmf = 1

# Protection Text : Strip-o-Gram HTML Conversion Library
try:
        from Products.stripogram import html2safehtml
except:
        have_stripogram = 0
        from Products.PythonScripts.standard import html_quote
        def html2safehtml(s, valid_tags=('b', 'a', 'i', 'br', 'p')):
	    return html_quote(s)
else:
        have_stripogram = 1
	
try:
	from Products.LocalFS import LocalFS
except:
	have_localfs = 0
else:
	have_localfs = 1

try:
	from photo_edition.IMG_start import *
	from photo_edition.image_modif import Image_modif
except:
	have_PIL = 0
else:
	have_PIL = 1

try:
	from Products.Localizer import LocalDTMLFile
	from Products.Localizer import LocalPageTemplateFile
	from Products.Localizer import Gettext
	zpsgettext = Gettext.translation(globals())
except:
	have_localizer = 0
	from Globals import DTMLFile
	from Products.PageTemplates.PageTemplateFile import PageTemplateFile
	LocalDTMLFile = DTMLFile
	LocalPageTemplateFile = PageTemplateFile
	del DTMLFile
	del PageTemplateFile
else:
	have_localizer = 1

if(not have_localizer):
	from ZPhotoSlidesUtils import zpsgettext
_ = zpsgettext

def upload_file(path,_prefix=None):
        if _prefix is None: _prefix=SOFTWARE_HOME
        elif type(_prefix) is not type(''):
            _prefix=package_home(_prefix)
        path = os.path.join(_prefix, path)

        file=open(path, 'rb')
        data=file.read()
        file.close()
        return data

def find_convert():
	if(os.name == 'posix'):
		for elem in ('/usr/bin/convert','/usr/sbin/convert','/usr/local/bin/convert'):
			if(os.path.isfile(elem)):
				return elem
	return ''

def find_tmp_folder():
	tmpdir = ''
	for tmpdir in ('c:\Tmp','/tmp','c:\windows\Temp','c:\winnt\Temp','c:\\'):
                if(os.path.isdir(tmpdir)):
			result = tmpdir
			break
	return result

factory_type_information = {
  'id'             : 'ZPhotoSlides',
  'portal_type'    : 'ZPhotoSlides',
  'meta_type'      : 'ZPhotoSlides',
  'description'    : 'A photo album',
  'content_icon'   : 'photo.gif',                          # Icon has to be acquired from a skin folder
  'product'        : 'ZPhotoSlides',
  'factory'        : 'manage_addZPhotoSlides',
  'immediate_view' : 'metadata_edit_form',
  'filter_content_types' : 0,                                   # This is for folderish types
  'allowed_content_types': (),           # If filter_content_types is true, this field can hold allowed meta_types
  'actions': (
    {
    'id'           : 'view',
    'name'         : 'View',
    'action'       : 'index_html',
    'permissions'  : (CMFCorePermissions.View, ),
    'category'      : 'object',
    },
    {
    'id'           : 'edit',
    'name'         : 'Edit',
    'action'       : 'ZPhotoSlidesEdit',
    'permissions'   : (CMFCorePermissions.ModifyPortalContent, ),
    'category'      : 'object',
    },
    {
    'id'            : 'metadata',
    'name'          : 'Metadata',
    'action'        : 'metadata_edit_form',
    'permissions'   : (CMFCorePermissions.ModifyPortalContent, ),
    'category'      : 'object',
    },
    ),
}

manage_addZPhotoSlidesForm = LocalDTMLFile('dtml/ZPhotoSlidesAdd',globals(),zpsgettext=zpsgettext,found_tmp=find_tmp_folder(),have_stripogram=have_stripogram,have_localizer=have_localizer,have_PIL=have_PIL,convert=find_convert(),have_localfs=have_localfs)

MessageDialog2 = HTML(upload_file(os.path.join('dtml','dialog2.dtml'),globals()), target='',action='manage_main', title='Changed',id='id',id_content='',URL1='',zpsgettext=zpsgettext)

def create_folder(path): # recursive folder creation
    if(not os.path.isdir(path)):
	    path1,path2 = os.path.split(path)
	    create_folder(path1)
	    os.mkdir(path)

def manage_addZPhotoSlides(self,id,photo_folder,postcard,thumb_prefix,width,height,tmp_folder,allow_new_folder,lib,convert='',manager_mail='',small=0,medium=0,large=0,double_name=1,remove=0,title='',recursive=0,REQUEST=None):
    """Add a ZPhotoSlides to a folder."""
    elapse = time.time()
    c_elapse = time.clock()
    result = ''
    id = string.strip(id)
    if(id == ''):
	raise IOError,"You didn't enter a valid id! ('" + id + "') !!"
    if(lib=="IM"):
	    if(convert=='' or (not os.path.isfile(convert))):
		    raise IOError,"Can't find Image Magick CONVERT in '%s'!" % convert
    if(allow_new_folder=="1"):
	    if(not os.path.isdir(photo_folder)): # folder doesn't exist and allow to create it
		
		try:
			create_folder(photo_folder)
		except:
			raise IOError,"You don't have the right to create folder %s !" % photo_folder
    else:
	    if(not os.path.isdir(photo_folder)):
		false_path = 1
		raise IOError,'Error: %s : folder unknown!!' % photo_folder
	    
    
    try:
	os.chdir(photo_folder)
    except:
	raise IOError,"Error: The Zope user (often www-data or nobody) can't explore the folder: %s ! \n Please change the rights on this directory! " % (photo_folder)
    if(not os.path.isdir(tmp_folder)):
	raise IOError,'Error: %s : folder unknown!!' % tmp_folder
    try:
	os.chdir(tmp_folder)
    except:
	raise IOError,"Error: The Zope user (often www-data or nobody) can't explore the folder: %s ! \n Please change the rights on this directory! " % (tmp_folder)
    if(postcard and (not re.search(r"^([\w_\.\-])+\@(([\w\-])+\.)+([\w]{2,4})+$", manager_mail))):
	raise IOError,"You didn't enter a valid email!"
    tmpdir = tmp_folder
    position = len(self.objectValues(['ZPhotoSlides Folder','ZPhotoSlides'])) + 1 # position = len(self.objectValues("ZPhotoSlides")) + 1
    try: # solve problem with version 1.1 and 1.0 of localizer
    	img = LocalFS.LocalFS('img','Local Images',photo_folder,username=None,password=None)
    except TypeError:
	img = LocalFS.LocalFS('Local Images',photo_folder,'','')
	img.id = str('img')
        localfsver = "1.1"
    else:
	localfsver = "1.0"

    #self.manage_addLocalFS('img','Local Images',photo_folder)
    if(not os.path.isdir(os.path.join(tmpdir,'thumb'))): os.mkdir('thumb')
    tmpdir = os.path.join(tmpdir,'thumb')
    if(localfsver=="1.0"):
    	tmpwork = LocalFS.LocalFS('tmp','Local Temporary Folder',tmpdir,username=None,password=None)
    else:
	tmpwork = LocalFS.LocalFS('Local Temporary Folder',tmpdir,'','')
      	tmpwork.id = str('tmp')
    self._setObject(id, ZPhotoSlides(id,img,tmpwork,tmpdir,thumb_prefix,position,lib,convert,title))
    ZPS = self._getOb(id)
    ZPS._setObject('img', img)
    ZPS._setObject('tmp', tmpwork)
    ZPS.format_available = ['full']
    ZPS.thumb_width = width
    ZPS.manager_mail = manager_mail
    ZPS.thumb_height = height
    ZPS.localfsver = localfsver
    ZPS.show_postcard = REQUEST.postcard
    ZPS.show_ARpostcard = REQUEST.postcard
    ZPS.show_rating = REQUEST.ratings
    
    if(REQUEST.postcard==1):
	    ZPS.mailhost = REQUEST.mailhost
	    ZPS.mailport = REQUEST.mailport
	    ZPS.zmailhost = MailHost.MailHost('zmailhost', '',REQUEST.mailhost,REQUEST.mailport)
    else:
	    ZPS.mailhost = ''
	    ZPS.mailport = ''
    # upload thumbnails
    if(result == None or result == ''):   
	result = ZPS.ask_4_thumbnails(destination=ZPS.thumbnails,prefix=thumb_prefix,width=width,height=height,recursive=recursive,remove=0,double_name=double_name,REQUEST=None)
    else:
	    result = result + ZPS.ask_4_thumbnails(destination=ZPS.thumbnails,prefix=thumb_prefix,width=width,height=height,recursive=recursive,remove=0,double_name=double_name,REQUEST=None)
    ZPS.get_nbr_non_hidden_thumb()
    if(small == 'on'):
	ZPS.manage_addFolder('small',createPublic=0,createUserF=0,REQUEST=None)
	ZPS.ask_4_thumbnails(destination=ZPS.small,prefix=thumb_prefix,width=320,height=320,recursive=recursive,remove=0,double_name=double_name,REQUEST=None)
	ZPS.format_available.append('small')
    if(medium == 'on'):
	ZPS.manage_addFolder('medium',createPublic=0,createUserF=0,REQUEST=None)
    	ZPS.ask_4_thumbnails(destination=ZPS.medium,prefix=thumb_prefix,width=480,height=480,recursive=recursive,remove=0,double_name=double_name,REQUEST=None)
	ZPS.format_available.append('medium')
    if(large == 'on'):
	ZPS.manage_addFolder('large',createPublic=0,createUserF=0,REQUEST=None)
	ZPS.ask_4_thumbnails(destination=ZPS.large,prefix=thumb_prefix,width=768,height=768,recursive=recursive,remove=0,double_name=double_name,REQUEST=None)
	ZPS.format_available.append('large')
    if('medium' in ZPS.format_available):
    	ZPS.default_photo_size = 'medium'
    elif('large' in ZPS.format_available):
	ZPS.default_photo_size = 'large'
    elif('small' in ZPS.format_available):
	ZPS.default_photo_size = 'small'
    else:
	ZPS.default_photo_size = 'full'
    # upload all python scripts
    ZPS.thumbnails.amount_photo = ZPS.get_thumb_amount()
    ZPS._setObject('batch_slides', PythonScript.PythonScript('batch_slides'))
    ZPS.batch_slides.write(upload_file('batch_slides.py',globals()))
    ZPS.list_comment = comment.comments()
    ZPS.list_postalcard = postalcard.postalcards()
    ZPS.list_rating = rating.ratings()
    ZPS.new_permission()
    elapse = time.time() - elapse
    c_elapse = time.clock() - c_elapse
    result = result + "<br> <font color=\"green\"><br>Time needed: %s s <br>CPU Time needed: %s s<br></font>" % (elapse,c_elapse)
    return MessageDialog2(
                title = 'ZPhotoSlides Added',
                message1 = result,
                action = 'manage_main',
                id = '',
                id_content = '',
                URL1 = REQUEST.URL1,
                actual_css = ZPS.actual_css
                )

class ZPhotoSlides(
    Folder,
    OFS.SimpleItem.Item,   # A simple Principia object. Not Folderish.
    Persistent,            # Make us persistent. Yaah!
    Acquisition.Implicit,  # Uh, whatever.
    AccessControl.Role.RoleManager # Security manager.
    ):
    "ZPhotoSlides 1.2"
    access=AccessControl.getSecurityManager()
 
    security = AccessControl.ClassSecurityInfo()
    meta_type = 'ZPhotoSlides' # what do people think they're adding?
    
    if(have_localizer):
    	locale = package_home(globals()) + '/locale/'
    	_zpsgettext = zpsgettext
    	

    manage_options = ( # what management options are there?
#	               {'label': 'Contents',       'action': 'manage_main'},
	               {'label': "Properties", 'action': 'manage_props'},
		       {'label': "View",       'action': 'index_html'}, # defaults to index_html
		       {'label': "Edit layout", 'action': 'user_layout'},
                       {'label': "List all files & Edit Photo", 'action': 'list_files'},
		       {'label': "Add photos", 'action':'add_photo'},
                       {'label': "Make thumbnails", 'action': 'make_thumb'},
		       {'label': "Manage thumbnails", 'action': 'change_title'},
		       {'label': "Statistics",'action':'stat_zphoto'},
		       {'label': "Manage comments",'action': 'manage_comment'},
		       {'label': "Manage PostCards",'action': 'manage_postalcard'},
		       {'label': "Manage Ratings",'action': 'manage_rating'},
		       {'label': "Choose symbolic photo",'action': 'choose_symbolic_pic'},
	               {'label': "Security",   'action': 'manage_access'},
		       {'label': "About this product",   'action': 'about'}
		     )

    __ac_permissions__=( # what permissions make sense for us?
		         ('View management screens', ('manage_tabs','manage_main')),
			 ('Change permissions',      ('manage_access',)           ),
		         ('Change ZPhotoSlides'     ,     ('manage_edit',)             ),
		       )

    # ZPT
    index_html_zpt = LocalPageTemplateFile('zpt/index_html',globals(),gettext=zpsgettext)
    view_photo_zpt = LocalPageTemplateFile('zpt/view_photo',globals(),gettext=zpsgettext) 
    view_movie_zpt = LocalPageTemplateFile('zpt/view_movie',globals(),gettext=zpsgettext) 
    postcard_zpt = LocalPageTemplateFile('zpt/postcard',globals(),gettext=zpsgettext) 
    postcard_mail_zpt = LocalPageTemplateFile('zpt/postcard_mail',globals(),gettext=zpsgettext) 
    postcardAR_mail_zpt = LocalPageTemplateFile('zpt/postcardAR_mail',globals(),gettext=zpsgettext) 
    postcardNotif_mail_zpt = LocalPageTemplateFile('zpt/postcardNotif_mail',globals(),gettext=zpsgettext) 
    view_card_zpt = LocalPageTemplateFile('zpt/view_card',globals(),gettext=zpsgettext) 
    add_comment_zpt = LocalPageTemplateFile('zpt/add_comment',globals(),gettext=zpsgettext)
    batch_macros = LocalPageTemplateFile('zpt/batch_macros',globals(),gettext=zpsgettext)
    footer = LocalPageTemplateFile('zpt/footer',globals(),gettext=zpsgettext)
    header = LocalPageTemplateFile('zpt/header',globals(),gettext=zpsgettext)
    ratings_box_zpt = LocalPageTemplateFile('zpt/ratings_box',globals(),gettext=zpsgettext)
    ratings_view = LocalPageTemplateFile('zpt/ratings_view',globals(),gettext=zpsgettext)
    breadcrumb = ZPhotoSlidesUtils.breadcrumb
    updateVisited = ZPhotoSlidesUtils.updateVisited 
    parse_ext = ZPhotoSlidesUtils.parse_ext
    
    # html & dtml files
    manage_tabs = LocalDTMLFile('dtml/manage_tabs',globals(),zpsgettext=zpsgettext)
    index_html = LocalDTMLFile('dtml/index_html',globals(),zpsgettext=zpsgettext)
    getcomment = LocalDTMLFile('dtml/getcomment',globals(),zpsgettext=zpsgettext)
    getrating = LocalDTMLFile('dtml/getrating',globals(),zpsgettext=zpsgettext)
    getratingall = LocalDTMLFile('dtml/getratingall',globals(),zpsgettext=zpsgettext)
    slide_show = LocalDTMLFile('dtml/slide_show',globals(),zpsgettext=zpsgettext)
    view_photo = LocalDTMLFile('dtml/view_photo',globals(),zpsgettext=zpsgettext) 
    view_movie = LocalDTMLFile('dtml/view_movie',globals(),zpsgettext=zpsgettext) 
    list_files = LocalDTMLFile('dtml/list_files',globals(),zpsgettext=zpsgettext)
    ratings_box = LocalDTMLFile('dtml/rating_box',globals(),zpsgettext=zpsgettext)
    manage_props = LocalDTMLFile('dtml/ZPhotoSlidesEdit', globals(),zpsgettext=zpsgettext) # Management Interface
    make_thumb = LocalDTMLFile('dtml/make_thumb',globals(),zpsgettext=zpsgettext) # form for making the thumb
    edit_image = LocalDTMLFile('dtml/edit_photo',globals(),zpsgettext=zpsgettext)
    change_title = LocalDTMLFile('dtml/list_title',globals(),zpsgettext=zpsgettext)
    add_comment = LocalDTMLFile('dtml/add_comment',globals(),zpsgettext=zpsgettext)
    edit_comment = LocalDTMLFile('dtml/edit_comment',globals(),zpsgettext=zpsgettext)
    choose_color = LocalDTMLFile('dtml/choose_color',globals(),zpsgettext=zpsgettext)
    about = LocalDTMLFile('dtml/about',globals(),zpsgettext=zpsgettext)
    define_css = LocalDTMLFile('dtml/define_css',globals(),zpsgettext=zpsgettext)
    user_layout = LocalDTMLFile('dtml/user_layout',globals(),zpsgettext=zpsgettext)
    choose_symbolic_pic = LocalDTMLFile('dtml/choose_symbolic_pic',globals(),zpsgettext=zpsgettext)
    manage_comment = LocalDTMLFile('dtml/manage_comment',globals(),zpsgettext=zpsgettext)
    manage_postalcard = LocalDTMLFile('dtml/manage_postalcard',globals(),zpsgettext=zpsgettext)
    manage_rating = LocalDTMLFile('dtml/manage_rating',globals(),zpsgettext=zpsgettext)
    stat_zphoto = LocalDTMLFile('dtml/stat_zphoto',globals(),zpsgettext=zpsgettext)
    add_photo = LocalDTMLFile('dtml/add_photo',globals(),zpsgettext=zpsgettext)
    css_info = HTMLFile('dtml/stylesheet_demo.css',globals(),zpsgettext=zpsgettext)
    plone_css = HTMLFile('dtml/plone_base_css',globals(),zpsgettext=zpsgettext)
    postcard = LocalDTMLFile('dtml/postcard',globals(),zpsgettext=zpsgettext)
    postcard_mail = LocalDTMLFile('dtml/postcard_mail',globals(),zpsgettext=zpsgettext)
    postcardNotif_mail = LocalDTMLFile('dtml/postcardNotif_mail',globals(),zpsgettext=zpsgettext)
    postcardAR_mail = LocalDTMLFile('dtml/postcardAR_mail',globals(),zpsgettext=zpsgettext)
    view_card = LocalDTMLFile('dtml/view_card',globals(),zpsgettext=zpsgettext)
    # secure the html
    security.declarePublic('index_html','batch_slides','view_photo','getcomment','postcard','')
    security.declareProtected('View management screens','manage_tabs','choose_symbolic_pic','img','get_all_css','about','define_css','user_layout','list_files','change_title','edit_image','make_thumb','manage_main','manage_props','edit_comment','comment_for_manage','give_all_images','choose_symbolic_pic','manage_comment','manage_postalcard','manage_rating','stat_zphoto','add_photo')
    security.declarePrivate('postcard_mail','postcardNotif_mail','postcardAR_mail')
    security.declarePrivate('postcard_mail_zpt','postcardNotif_mail_zpt','postcardAR_mail_zpt')

    def __init__(self, id,img,tmpwork,tmpdir,thumb_prefix,position,lib,convert,title=''):
        """initialise a new instance of ZPhotoSlides"""
	self.id = id                            # id name
        self.version = VERSION                  # zphotslides version
        self.update_date = DATE                 # last update
        self.title = title                      # title of zphotoslides
        self.thumb_prefix = thumb_prefix        # prefix for the thumbnails (default to "tn_")
        self.image_folder = img                 # image source folder on fs
        self.tmp_dir = tmpdir                   # temp folder on fs
	self.position = position
	self.lib = lib
	self.show_rating = 0
	self.visits_log = stat()
        self.layout_list = layout.give_list()   # list of the css options
        self.manage_addFolder('thumbnails', 'Thumbnails', createPublic=0,createUserF=0, REQUEST=None) # thumbnails in zodb
        self.manage_addFolder('css', 'Thumbnails', createPublic=0,createUserF=0, REQUEST=None)   # css files in zodb
        self.css._setProperty('amount_css',1,'int')
        self.css.manage_addDTMLMethod('stylesheet_base_css', 'Main ZPhotoSlides Stylesheet', self.css_info, REQUEST=None)
        self.css.manage_addDTMLMethod('plone_css', 'Plone ZPhotoSlides Stylesheet', self.plone_css, REQUEST=None)
        self.actual_css = 'stylesheet_base_css' # main stylesheet
        self.thumbnails._setProperty('amount_photo',self.get_thumb_amount(),'int')
        self.non_hidden_pic = 0                 # amount of photos not hidden and visible for normal user
        self.list_non_hidden_pic = []           # list of the photos not hidden and visible for normal user
        self.rows = 3                           # default amount of row for layout in rendering the main table of photos
        self.column = 3                         # default amount of colum for layout in rendering the main table of photos
        self.zphoto_header= ''                  # get content of standard header
        self.list_photo = {}                    # list of all the photos
        self.zphoto_footer= ''                  # get content of standard footer
        self.symbolic_photo = ''                # name of the selected symbolic photo
        self.keywords = ''                      # keywords describing the object
        self.description = ''                   # description of the object
        self.first_big = 0                      # default size for slide show
        self.show_comment = 1                   # bool to print or not the comments
	self.show_postcard = 0
	self.show_ARpostcard = 0
        self.show_automatic_slide_show = 1      # bool to print or not the slideshow
        self.show_viewed = 1                    # bool to print or not the amount of visitors for a photo
	self.show_exif = 1			# show the exif infos!
	self.photo_space = 30			# space between the photos in index_html
	self.convert = convert			# image magick location
	self.last_modif = DateTime()

    def getBatch(self, files, b_size, b_start, orphan):
      """ Patch ZPT """
      return Batch(files, b_size, int(b_start), orphan=0)
    
    security.declarePrivate('check_tmp_folder')
    def check_tmp_folder(self):
	if(not os.path.isdir(self.tmp_dir)):
		try:
			os.mkdir(self.tmp_dir)
		except:
			assert (IOError,_("Can't create temporary thumb folder in ") + self.tmp_dir)
	try:
		os.chdir(self.tmp_dir)
	except:
		raise (IOError,_("Error: The Zope user (often www-data or nobody) can't explore the folder:") + self.tmp_dir +_("!\n Please change the rights on this directory!"))
        if(not os.access(self.tmp_dir,os.W_OK)):
                raise (IOError,_("Error: Zope user (often www-data, www or nobody) can't write in directory") + self.tmp_dir + _("!! Please change the rights on this directory"))
        if(not os.access(self.tmp_dir,os.R_OK)):
                raise (IOError,_("Error: Zope user (often www-data, www or nobody) can't read in directory") + self.tmp_dir + _("!! Please change the rights on this directory"))
	self.remove_thumbnails_from_disk()

    security.declarePublic('rate_content')
    def rate_content(self,id_photo=None,rating=None,REQUEST=None):
      " Rate Content "
      sessionID = self.generateId()
      comment = ''
      try:
        self.list_rating.add_new(sessionID,id_photo,rating,comment)
        status_msg = _('Rating has been calculated.')
      except:
        status_msg = _('Anonymous not allowed to rate content.')
      REQUEST.set('message_admin',status_msg)
      REQUEST.set('photoid',id_photo)
      return self.ratings_box(REQUEST=REQUEST,zpsgettext=zpsgettext,message_admin=status_msg,photoid=id_photo)
    
    security.declarePublic('get_rating_all')
    def get_rating_all(self):
        "Print all ratings for a photo"
	liste_dictrate = []
	for elem in self.list_rating:
	            dictrate = {}
		    dictrate['sessionID'] = elem.sessionID
		    dictrate['id_photo'] = elem.id_photo
		    dictrate['rating'] = elem.rating
		    dictrate['comment'] = elem.comment
		    liste_dictrate.append(dictrate)
	return liste_dictrate
	
    security.declarePublic('get_rating_list')
    def get_rating_list(self,id_photo):
        "Print all ratings for a photo"
	liste_dictrate = []
	for elem in self.list_rating:
	    if(elem.id_photo==id_photo):
	            dictrate = {}
		    dictrate['sessionID'] = elem.sessionID
		    dictrate['id_photo'] = elem.id_photo
		    dictrate['rating'] = elem.rating
		    dictrate['comment'] = elem.comment
		    liste_dictrate.append(dictrate)
	return liste_dictrate

    security.declarePublic('get_rating')    
    def get_rating(self,id_photo):
	"Print the ratings for a Photo"
        liste_dict = {}                             # new list
	total = 0
        for elem in self.list_rating:               # for all ratings
            if(elem.id_photo==id_photo):                   #   if rating for the photo
	            total += 1
		    if (elem.rating not in liste_dict.keys()):
		       liste_dict[elem.rating] = 1
		    else:
		       liste_dict[elem.rating] = liste_dict[elem.rating] + 1
	for elem in liste_dict.keys():
	    liste_dict[elem] = (round((float(liste_dict[elem])/float(total))*100.0,2), liste_dict[elem])
        return liste_dict                               # we return the list
 
    security.declarePublic('get_ratingfolder')    
    def get_ratingfolder(self):
        "Print the ratings for Album"
	liste = {}
	total = len(self.list_rating)
	for elem in self.list_rating:
		if (elem.rating not in liste.keys()):
			liste[elem.rating] = 1
		else:
			liste[elem.rating] = liste[elem.rating] + 1
				
	for elem in liste.keys():
                liste[elem] = (round((float(liste[elem])/float(total))*100.0,2),liste[elem])
	return liste
    
    security.declarePrivate('generateId')
    def generateId(self):
	" Generate a unique, random id"
        s=string.lowercase + string.digits
        newid=''
        #suffix is 20 characters long
        for x in range(20):
        	newid=newid+whrandom.choice(s)
	return newid
	
    security.declarePrivate('validEmail')    
    def validEmail(self,address):
	"Return true if the supplied email address is in a valid format"
	if re.search(r"^([\w_\.\-])+\@(([\w\-])+\.)+([\w]{2,4})+$", address):
	   return 1
        else:
	   return 0
    security.declarePublic('send_notification_postcard')   
    def send_notification_postcard(self,REQUEST,AR,n_from=None,e_from=None,n_to=None,e_to=None,sessionID=None,date=None):
	    if(int(AR) == 1):
		    REQUEST.set('name_to',n_to);
		    REQUEST.set('email_to',e_to);
	            REQUEST.set('name_from',n_from);
		    REQUEST.set('email_from',e_from);
		    REQUEST.set('sessionID',sessionID);
		    REQUEST.set('date',date);
		    mail_text_AR = self.postcardAR_mail(REQUEST=REQUEST)
	            self.zmailhost.send( str(mail_text_AR) )
		    for elem in self.list_postalcard:
			    if(elem.id==sessionID):
				    elem.AR = 0
				    break
	    return 1

    security.declarePublic('send_postcard')
    def send_postcard(self,picture=None,name_to0=None,name_to1=None,name_to2=None,name_to3=None,name_to4=None,email_to0=None,email_to1=None,email_to2=None,email_to3=None,email_to4=None,name_from=None,email_from=None,comment=None,size=None,REQUEST=None):
	"verification and send"
	message_admi=''
	if((name_to0=='') or (name_to1=='') or (name_to2=='') or (name_to3=='') or (name_to4=='') ):
		message_admi=message_admi + _('You must enter the recipients Name.<br>')
	if((email_to0=='') or (email_to1=='') or (email_to2=='') or (email_to3=='') or (email_to4=='') ):
	    message_admi=message_admi + _('You must enter a recipients Email.<br>')
	if(self.validEmail(email_to0)==0):
	    message_admi=message_admi + _('The recipients email is incorrect.<br>')
	if(name_from == ''):
	    message_admi=message_admi + _('You must enter your Name.<br>')
	if(email_from == ''):
	    message_admi=message_admi + _('You must enter your Email.<br>')
	if(self.validEmail(email_from)==0):
	    message_admi=message_admi + _('Your email is incorrect<br>')
	if(comment == ''):
	    message_admi=message_admi + _('You must enter your message<br>')
	if(message_admi != ''):
	    REQUEST.set('message_admin',message_admi)
	    return self.postcard_zpt(REQUEST=REQUEST)
	if REQUEST is not None:
	    times = time.strftime('%H:%M:%S %d-%m-%Y', time.localtime()) # when the postalcard is add
	    if REQUEST['AR'] is None:
		    pcAR = 0
	    else:
		    pcAR = int(REQUEST['AR'])
		    
	    message_admi = _('Your PostCard was send, using the unique number:')
	    
	    message_admini = self.send_postcard_nx(picture=picture,nameto=name_to0,emailto=email_to0,name_from=name_from,email_from=email_from,comment=comment,times=times,pcAR=pcAR,size=size,REQUEST=REQUEST)
	    message_admi = message_admi + message_admini
	    
	    if((name_to1!='') and (name_to1!='None') and (email_to1!='') and (email_to1!='None')):
	        message_admini = self.send_postcard_nx(picture=picture,nameto=name_to1,emailto=email_to1,name_from=name_from,email_from=email_from,comment=comment,times=times,pcAR=pcAR,size=size,REQUEST=REQUEST)
		message_admi = message_admi + ', ' + message_admini

	    if((name_to2!='') and (name_to2!='None') and (email_to2!='') and (email_to2!='None') ):
	        message_admini = self.send_postcard_nx(picture=picture,nameto=name_to2,emailto=email_to2,name_from=name_from,email_from=email_from,comment=comment,times=times,pcAR=pcAR,size=size,REQUEST=REQUEST)
		message_admi = message_admi + ', ' + message_admini
	    
	    if((name_to3!='') and (name_to3!='None') and (email_to3!='') and (email_to3!='None') ):
	        message_admini = self.send_postcard_nx(picture=picture,nameto=name_to3,emailto=email_to3,name_from=name_from,email_from=email_from,comment=comment,times=times,pcAR=pcAR,size=size,REQUEST=REQUEST)
		message_admi = message_admi + ', ' + message_admini
	    
	    if((name_to4!='') and (name_to4!='None') and (email_to4!='') and (email_to4!='None') ):
	        message_admini = self.send_postcard_nx(picture=picture,nameto=name_to4,emailto=email_to4,name_from=name_from,email_from=email_from,comment=comment,times=times,pcAR=pcAR,size=size,REQUEST=REQUEST)
		message_admi = message_admi + ', ' + message_admini
	    
	    REQUEST.set('message_admin',message_admi)
	    REQUEST.set('photoid',picture)
	    return self.view_photo(photoid=picture,REQUEST=REQUEST,zpsgettext=zpsgettext)

    security.declarePrivate('send_postcard_nx')
    def send_postcard_nx(self,picture=None,nameto=None,emailto=None,name_from=None,email_from=None,comment=None,times=None,pcAR=None,size=None,REQUEST=None):
        name_to = nameto
        email_to = emailto
        sessionID = self.generateId() 
	REQUEST.set('name_to',nameto)
	REQUEST.set('email_to',emailto)
	REQUEST.set('sessionID',sessionID)
        if(int(REQUEST['ARref'])==1):
	    mail_textNoAR=self.postcardNotif_mail(REQUEST,name_to,email_to,name_from,email_from,sessionID,zpsgettext=zpsgettext)
	    self.zmailhost.send(str(mail_textNoAR))
        self.list_postalcard.add_new(picture,sessionID,name_to,email_to,name_from,email_from,comment,times,pcAR,size,REQUEST.REMOTE_ADDR)
	mail_text = self.postcard_mail(name_to,email_to,name_from,email_from,sessionID)
	self.zmailhost.send(str(mail_text))
	message_admi = sessionID
	return message_admi
	
    security.declarePrivate('visited')
    def visited(self,REQUEST):
        iplog = self.visits_log.ip_log(REQUEST)
	self.visits_log.new_visit(iplog,REQUEST)
    
    security.declarePublic('get_exif_infos')
    def get_exif_infos(self,photo_id):
	try:
		res = self.list_photo[photo_id + '_info']
	except:
		res = {}
	return res

    security.declarePrivate('needupgrade')
    def needupgrade(self):
	if(self.version != VERSION):
		return 1
	else:
		return 0	

    security.declareProtected('View management screens','upgrade')
    def upgrade(self,REQUEST=None):
	"Allow the user to upgrade object created in former versions"
	attr_list = [ ("format_available",['full']) ,
		("position",len(self.aq_parent.objectValues(['ZPhotoSlides','ZPhotoSlides Folder'])) + 1),
		("default_photo_size",'full'),
		("thumb_width",200),
		("thumb_height",200),
		("visits_log", stat()),
		("show_rating",0),
		("show_exif",1),
		("show_postcard",1),
		("show_ARpostcard",0),
		("list_postalcard",postalcard.postalcards()),
		("list_rating",rating.ratings()),
		("mailhost",'localhost'),
		("mailport",25),
		("zmailhost",MailHost.MailHost('zmailhost','','localhost',25)),
		("manager_mail",''),
		("last_modif",DateTime()),
		("lib",'PIL')
		]

	for attr,default_val in attr_list:
		if not self.__dict__.has_key(attr):
			setattr(self,attr,default_val)

	if(self.version == '0.8'):
		if(have_localizer):
        		locale = package_home(globals()) + '/locale/'
		        _zpsgettext = zpsgettext
		self.version = '0.9' # seems we don't have anything to modify except this
		
	
	if(self.version == '0.9'):
		# add keyword properties for each photos
		for img in self.thumbnails.objectValues():
			try:
				img._setProperty('keywords',[],'tokens')
			except:
				pass
		self.version = '1.0'
		
	if(self.version == '1.0'):
		self.show_postcard = 1
		self.version = '1.1'
		
	if(self.version == '1.1'):
	        self.show_rating = 0

	# ZPhotoslides upgraded!
	self.version = VERSION
	#self.visits_log = stat()
	if(REQUEST!=None):
		return self.manage_props(REQUEST,manage_tabs_message='ZPhotoSlides Upgraded !')
    def new_permission(self):
	"define new permission"
	self.manage_permission('Upload local files',('Manager','Owner'),acquire=0)
	
    security.declarePublic('use_comment')
    def use_comment(self,id_photo,name,commt,place,email,REQUEST):
	"add a new comment for id_photo"
	times = time.strftime('%H:%M:%S %d-%m-%Y', time.localtime()) # when the comment is add
	clean_commt = html2safehtml(commt, valid_tags=('b','a','i','br','p'))
        iplog = self.visits_log.ip_log(REQUEST)
        self.list_comment.add_new(id_photo,clean_commt,name,place,times,iplog,email)
	REQUEST.set('photoid',id_photo)
	ext = ZPhotoSlidesUtils.parse_ext(self,id_photo)
        if REQUEST is not None:
	   if (ext == 'mov' or ext=='rm' or ext=='ram' or ext=='swf' or ext=='mpe' or ext=='mpeg'):
	        return self.view_movie(REQUEST=REQUEST)
	   else:
		return self.view_photo(REQUEST=REQUEST)
                
    security.declareProtected('View management screens','choose_symbolic_photo')
    def choose_symbolic_photo(self,photo_name=None,REQUEST=None):
	"Choose the symbolic photo for the ZPhotoSlides Folder"
	if(photo_name != None):
		self.symbolic_photo = photo_name
		self.last_modif = DateTime()
		comment = _('Change of symbolic photo sucessful! <br> Symbolic photo is now:') + photo_name
	else:
		comment = _('You forgot to choose a photo!')
	
	if REQUEST is not None:
		return self.choose_symbolic_pic(manage_tabs_message=comment)
    def has_comment(self,id_photo):
	"Has a comment for the photo"
	for elem in self.list_comment:
		if(elem.id==id_photo):
			return 1
	return 0
    def number_of_comments(self,id_photo):
	"Returns the number of comments"
	count = 0
	for elem in self.list_comment:
		if(elem.id == id_photo):
			count = count + 1
	return count

    
    def number_of_ratings(self,id_photo):
	"Returns the number of ratings"
	count = 0
	for elem in self.list_rating:
		if(elem.id_photo == id_photo):
			count = count + 1
	return count
	
    security.declarePublic('get_postcard_all')    
    def get_postcard_all(self):
	"Print all postcards for a photo"
        liste_dictcard = []                           # new list
        for elem in self.list_postalcard:             # for all postcards
                    dictcard= {}                      #   we add the postcard to the list
		    dictcard['id_photo'] = elem.id_photo
		    dictcard['sessionID'] = elem.sessionID
		    dictcard['n_to'] = elem.n_to
		    dictcard['e_to'] = elem.e_to
		    dictcard['n_from'] = elem.n_from
		    dictcard['e_from'] = elem.e_from
		    dictcard['commt'] = elem.commt
		    dictcard['date'] = elem.date
		    dictcard['AR'] = elem.AR
		    dictcard['size'] = elem.size
		    dictcard['ipadr'] = elem.adrip
                    liste_dictcard.append(dictcard)
        return liste_dictcard                               # we return the list

    security.declarePublic('get_postcard')    
    def get_postcard(self,sessionID):
	"Print the postcards for a photo"
        liste_dictcard = []                           # new list
        for elem in self.list_postalcard:             # for all postcards
	       if(elem.id==sessionID):                #   if postcard for the photo
                    dictcard= {}                      #   we add the postcard to the list
		    dictcard['id_photo'] = elem.id_photo
		    dictcard['sessionID'] = elem.sessionID
		    dictcard['n_to'] = elem.n_to
		    dictcard['e_to'] = elem.e_to
		    dictcard['n_from'] = elem.n_from
		    dictcard['e_from'] = elem.e_from
		    dictcard['commt'] = elem.commt
		    dictcard['date'] = elem.date
		    dictcard['AR'] = elem.AR
		    dictcard['size'] = elem.size
                    liste_dictcard.append(dictcard)
		    break
        return liste_dictcard                               # we return the list

    security.declarePublic('get_comment')    
    def get_comment(self,id_photo):
	"Print the comments for a photo"
        liste_dict = []                              # new list
        for elem in self.list_comment:               # for all comments
            if(elem.id==id_photo):                   #   if comment for the photo
                    dict= {}                         #       we add the comment to the list
                    dict['comment'] =elem.commt
                    dict['user'] = elem.user
                    dict['place'] = elem.place
                    dict['date'] = elem.date
                    dict['ip'] = elem.ip
                    dict['email'] = elem.email
                    liste_dict.append(dict)
        return liste_dict                               # we return the list

    security.declareProtected('View management screens','delete_rating')
    def delete_rating(self,sessionID,REQUEST):
	"Delete a rating from a photo fallowing the comment date"
	for rate in self.list_rating:
		if(rate.sessionID==sessionID):
			self.list_rating.remove(rate)
			break
	if REQUEST is not None:
		return self.manage_rating(manage_tabs_message=_('Rating deleted for')+ str(sessionID))
		
    security.declareProtected('View management screens','delete_postcard')
    def delete_postcard(self,sessionID,REQUEST):
	"Delete a postcard from a photo fallowing the comment date"
	for post in self.list_postalcard:
		if(post.sessionID==sessionID):
			self.list_postalcard.remove(post)
			break
	if REQUEST is not None:
		return self.manage_postalcard(manage_tabs_message=_('postal card deleted for')+ str(sessionID))
    
    security.declareProtected('View management screens','delete_comment')
    def delete_comment(self,photo_id,comment_date,REQUEST):
	"Delete a comment from a photo fallowing the comment date"
	for comment in self.list_comment:
		if(comment.id==photo_id and comment.date==comment_date):
			self.list_comment.remove(comment)
			break
	if REQUEST is not None:
		return self.manage_comment(manage_tabs_message=_('Comment deleted for')+ str(photo_id))
    
    security.declareProtected('View management screens','modify_comment')    
    def modify_comment(self,photo_id,old_date,date,name,email,place,commt,REQUEST):
	"Manager modify a comment"
	for comment in self.list_comment:
		if(comment.id==photo_id and comment.date==old_date):
			comment.date = date
			comment.user = name
			comment.email = email
			comment.place = place
			comment.commt = commt
			break
		
	if REQUEST is not None:
		return self.manage_comment(manage_tabs_message=_('Comment Modified for ')+ str(photo_id))

    security.declarePrivate('get_keywords')
    def get_keywords(self,photo_id):
	string = ''
	for imag in self.thumbnails.objectValues('Image'):
		if(imag.getId()==photo_id):
			cpt = 0
			for elem in imag.keywords:
			   if(cpt == 0):
				string = elem
			   else:
			   	string = string + ', ' + str(elem).strip()
			   cpt= cpt +1
			break
	return string		
    
    security.declarePrivate('get_nbr_non_hidden_thumb')
    def get_nbr_non_hidden_thumb(self):
	"return list of non hidden photos"
	images = self.thumbnails.objectValues('Image')
	nbr= len(images)
	list_thumb = []
	for img in images:
		if(img.__dict__.has_key('getviewit') and img.getviewit=='0'):
			nbr = nbr - 1
		else:
			list_thumb.append(img)
	self.non_hidden_pic = nbr
	self.list_non_hidden_pic = list_thumb
	self.list_non_hidden_pic.sort(lambda x, y: cmp(x.position, y.position))
	return self.list_non_hidden_pic

    security.declareProtected('View management screens','add_new_css')
    def add_new_css(self,REQUEST):
	"Add a new CSS file in css folder"
	title=REQUEST.title
	file = REQUEST.file
	id = 'css' + str(self.css.amount_css)
	self.css.manage_addDTMLMethod(id, title, file, REQUEST=None)
	self.css.amount_css = self.css.amount_css + 1
	self.actual_css = id
	if(REQUEST!=None):
		return self.user_layout(manage_tabs_message='Your CSS file has been added !')
    
    security.declareProtected('View management screens','use_uploaded_css')
    def use_uploaded_css(self,REQUEST):
	"Use a css which is in folder css"
	choosed = REQUEST.uploaded_css
	self.actual_css = choosed
	if(REQUEST!=None):
                return self.user_layout(manage_tabs_message='The Css file you choose is now used to define the layout !')

    security.declareProtected('View management screens','change_main_css')
    def change_main_css(self,REQUEST):
	"Change the main css tag for the Main ZPhotoSlides Stylesheet"
	dict = REQUEST.form
	for elem in dict.keys():
	   dic1,dic2 = string.split(elem,'__')
	   self.layout_list[dic1][dic2] = dict[elem]
	self.actual_css = 'stylesheet_base_css'
	if(REQUEST!=None):
		return self.user_layout(manage_tabs_message='Modifications saved for Main ZPhotoSlides Stylesheet!')

    security.declarePublic('give_header_4_robots')
    def give_header_4_robots(self):
	"give the header for the robots"
	return """
<meta name="KEYWORDS" content="%s" />
<meta name="DESCRIPTION" content="%s" />
<meta name="resource-type" content="document" />
<meta name="ROBOTS" content="INDEX,FOLLOW" />
<meta http-equiv="expires" content="0" />
<meta name="author" content="ZPhotoSlides" />
<meta name="copyright" content="ZPhotoSlides %s" />
<meta name="revisit-after" content="1 days" />
<meta name="rating" content="General" />""" % (self.keywords,self.description,self.version)
    
    security.declareProtected('View management screens','new_header_footer')
    def new_header_footer(self,REQUEST):
	"Change the standard_html_header and footer"
	self.zphoto_header = REQUEST.header
	self.zphoto_footer = REQUEST.footer
	if(REQUEST.header != '' or REQUEST.footer != ''):
                msg1 = _("""You use yet the standard html footer and header. To use the css files again
                make the standard html footer and header <u><i>EMPTY</i></u> in the layout formular!""")
                title_1 = "Using standard html header and footer"
        else:
		msg1 = _("You use yet the CSS file.")
		title_1 = _("Using CSS file")
	if(REQUEST!=None):
		return self.user_layout(manage_tabs_message=msg1)	

    security.declarePublic('get_photo_format_available')
    def get_photo_format_available(self,REQUEST):
	result = {}
	if(REQUEST.has_key('psize')):
		size = REQUEST.psize
	elif(REQUEST.has_key('ph_size')):
		size = REQUEST.ph_size
	else:
		size = self.default_photo_size

	self.format_available.sort()
	self.format_available.reverse()
	for elem in self.format_available:
		if(elem!=size):
			result[elem] = 'ok'
		else:
			result[elem] = ''
	return result

    security.declarePrivate('get_list_photo_4_slideshow')
    def get_list_photo_4_slideshow(self,REQUEST,full):
	"get the list of photos for the Javascript of the slideshow"
	list_string = ''
	cpt = 1
	for elem in self.list_non_hidden_pic:
		dict = {}
		if(full=='1'): # si full -> access au fichier en full
			#filename = elem.access.replace(' ','%20')
			#url = REQUEST.URL1 + '/img/' + filename
			filename = elem.getId().replace(' ','%20')
			url = REQUEST.URL1 + '/medium/' + filename
			string1 = 'photo_urls[%d] = "%s";' % (cpt,url)
			string2 = 'photo_captions[%d] = "%s";' % (cpt,elem.title_or_id())
			list_string = list_string + '\n' + string1 + '\n' + string2 + '\n'
		else:
			filename = elem.getId().replace(' ','%20')
			url_small = REQUEST.URL1 + '/thumbnails/' + filename
			string3 = 'photo_urls_small[%d] = "%s";' % (cpt,url_small)
			string2 = 'photo_captions[%d] = "%s";' % (cpt,elem.title_or_id())
			list_string = list_string + '\n' + string2 + '\n' + string3
                
		cpt = cpt + 1
	return list_string[1:]
	    
    security.declarePrivate('amount_photos')
    def amount_photos(self):
	return len(self.list_non_hidden_pic)

    security.declarePrivate('get_thumb')
    def get_thumb(self,thumb_id):
	for img in self.thumbnails.objectValues('Image'):
		if(img.getId()==thumb_id):
			thumb_pic = img
	return thumb_pic	
    security.declarePublic('photo_visited')   
    def photo_visited(self,thumb_id):
	"""increase the number of visit of a photo"""
	thumb_pic = ''
	for img in self.thumbnails.objectValues('Image'):
	    if(img.getId()==thumb_id):
		thumb_pic = img
	thumb_pic.viewed = int(thumb_pic.viewed) + 1
        return thumb_pic

    security.declarePrivate('getRandom')
    def getRandom(self):
	return random.randint(0,100)

    security.declarePublic('img_allow_show')
    def img_allow_show(self,img_name):
#	"return 1 if the image can be show"
	for img in self.thumbnails.objectValues('Image'):
		if(img.getId()==img_name):
			return int(img.getviewit)
	return 0

    security.declarePublic('getSlide')
    def getSlide(self,thumb_id):
	"""Give the number of the slide where is the photo"""
	thumb_pic = ''
	for img in self.thumbnails.objectValues('Image'):
	    if(img.getId()==thumb_id):
		thumb_pic = img
	pos= int(thumb_pic.position)
	tmp = (pos)/(self.rows*self.column)
	return tmp

    security.declarePublic('photo_hasPrev')
    def photo_hasPrev(self,thumb_id):
	"""Give the previous photo of the list"""
	thumb_pic = ''
	for img in self.thumbnails.objectValues('Image'):
	    if(img.getId()==thumb_id):
		thumb_pic = img
	pos = int(thumb_pic.position)
	min = 99999999
	min_photo = ''
	for img in self.list_non_hidden_pic:
	    if(img.getId()!=thumb_id and pos > img.position and pos-int(img.position)<min):
		min = pos-int(img.position)
		min_photo = img.getId()
	if(min_photo == ''):
		return ''
	else:
		return min_photo

    security.declarePublic('photo_hasNext')
    def photo_hasNext(self,thumb_id):
	"""Give the next photo of the list"""
	thumb_pic = ''
	for img in self.thumbnails.objectValues('Image'):
	    if(img.getId()==thumb_id):
		thumb_pic = img
	pos = int(thumb_pic.position)
	min = 999999999
	min_photo = ''
	for img in self.list_non_hidden_pic:
	    if(img.getId()!=thumb_id and pos < img.position and int(img.position)-pos < min):
		min = pos-int(img.position)
		min_photo = img.getId()
	if(min_photo == ''):
		return ''
	else:
		return min_photo

    def manage_edit(self,
title,show_exif,first_big,keywords,description,photo_space,show_comment,show_postcard,show_rating,show_ARpostcard,default_photo_size,rows,column,photo_folder,show_automatic_slide_show,show_viewed,manager_mail,REQUEST=None):
	"""does this really need a doc string?"""
	if(not self.validEmail(manager_mail)):
	        raise IOError,"You didn't enter a valid email!"
	self.manager_mail = manager_mail
	self.title = title
	self.default_photo_size = default_photo_size
	self.show_automatic_slide_show = int(show_automatic_slide_show)
	self.keywords = 'ZPhotoSlides,' + keywords
	self.description = description
	self.photo_space = int(photo_space)
	self.show_exif = int(show_exif)
	result = ''
	if(not os.path.isdir(photo_folder)):
        	result = '<font color="red"><b><u>%s</u> %s : %s</b></font><br>' % (_('Error:'),photo_folder,_('folder unknown'))
	else:
		old_basepath = self.image_folder.basepath
        	self.image_folder.basepath = photo_folder
		if(old_basepath != photo_folder):
                	self.remove_thumbnails()

	self.rows = int(rows)
	self.first_big = int(first_big)
	self.show_viewed = int(show_viewed)
	self.show_comment = int(show_comment)
	self.show_postcard = int(show_postcard)
	self.show_ARpostcard = int(show_ARpostcard)
	self.show_rating = int(show_rating)
	if(REQUEST.mailhost!=''):
		if(self.__dict__.has_key('zmailhost')):
			self.zmailhost.manage_makeChanges('',REQUEST.mailhost,REQUEST.mailport,None)
		else:
			self.zmailhost = MailHost.MailHost('zmailhost','',REQUEST.mailhost,REQUEST.mailport)
	self.column = int(column)
	self.last_modif = DateTime()
        if REQUEST is not None:
		message = _("Properties for") + ' ' +self.id  + ' ' +  _('changed') + ".<br> %s" % (result)
		return self.manage_props(REQUEST,manage_tabs_message=message)

    security.declarePrivate('remove_thumbnails')
    def remove_thumbnails(self):
	for img in self.thumbnails.objectValues('Image'):
		self.thumbnails.manage_delObjects(img.getId())

    security.declareProtected('View management screen','delete_thumbnail')
	
    security.declarePrivate('remove_thumbnails_from_disk')
    def remove_thumbnails_from_disk(self):
#	for img in self.tmp.objectIds():
	if (not self.__dict__.has_key('localfsver') or self.localfsver == "1.0"):
		for img in self.tmp.fileIds():
			tmpdir = os.path.join(self.tmp_dir,img)
			try:
				os.remove(tmpdir)
			except:
				pass # we dont want to delete folder
	else:
		for img in self.tmp.objectIds():
			tmpdir = os.path.join(self.tmp_dir,img)
			try:
				os.remove(tmpdir)
			except:
				pass # we dont want to delete folder

    security.declareProtected('View management screen','add_new_photo')
    def add_new_photo(self,REQUEST):
	"Add new photos"
	self.check_tmp_folder()
	self.remove_thumbnails_from_disk()
	os.chdir(self.tmp_dir)
        if(not os.path.isdir(os.path.join(self.tmp_dir,'new'))): 
		os.mkdir('new')
	else:
		if (not self.__dict__.has_key('localfsver') or self.localfsver == "1.0"):
		#for img in self.tmp.new.objectIds():
			for img in self.tmp.new.fileIds():
				tmpdir = os.path.join(self.tmp_dir,'new')
	                	tmpdir = os.path.join(tmpdir,img)
	                	try:
	                        	os.remove(tmpdir)
	                	except:
	                        	pass # we dont want to delete folder
	        else:
			for img in self.tmp.new.objectIds():
				tmpdir = os.path.join(self.tmp_dir,'new')
	                	tmpdir = os.path.join(tmpdir,img)
	                	try:
	                        	os.remove(tmpdir)
	                	except:
	                        	pass # we dont want to delete folder
		
	for elem in REQUEST.form.keys():
		file = REQUEST.form[elem]
		if(file.filename!=''):
			content = file.read()
			id, title = cookId(None,None,file)
			file_loc = os.path.join(self.tmp.basepath,'new')
			file_loc = os.path.join(file_loc,id)	
			path = self.tmp.basepath
			fd = open(file_loc, 'wb')
			fd.write(content)
			fd.close()
			os.chmod(file_loc, 0664)
			shutil.copyfile(file_loc,os.path.join(self.image_folder.basepath,id))

	olddir = self.image_folder.basepath
	self.image_folder.basepath = os.path.join(self.tmp_dir,'new')
	medium = ''
	small = ''
	large = ''
	if('medium' in self.format_available):
		medium = 'on'
	if('large' in self.format_available):
		large = 'on'
	if('small' in self.format_available):
		small = 'on'
	print self.image_folder.basepath
	self.manage_make_thumb('tn_',0,0,0,self.thumb_width,self.thumb_height,None,small,medium,large)
	self.image_folder.basepath = olddir
	self.last_modif = DateTime()
	return self.add_photo(REQUEST,manage_tabs_message='Photos Added!')

    security.declareProtected('View management screen','manage_make_thumb')
    def create_thumbnail(self,destination,prefix,thumb_img,width,height):
	self.check_tmp_folder()
	for elem in self.thumbnails.objectValues():
		if(thumb_img==elem.getId()):
			break
	path = elem.access
	new_list_photo = {}
	new_list_photo = thumbnail(path,destination,width,height,prefix)
	for elem in new_list_photo.keys():
                self.list_photo[elem] = new_list_photo[elem]
        infos = '<br>'
        for kei in self.list_photo.keys():
                tmp = self.list_photo[kei]
                if(type(tmp)=='' and tmp.find('Error') != -1):
                        infos = infos + '<br>' + tmp
                        del self.list_photo[kei]
	dict,amount = self.upload_thumbnails(destination,prefix)
	

    security.declareProtected('View management screen','manage_make_thumb')
    def manage_make_thumb(self,prefix,recursive,double_name,remove,width,height,REQUEST,small='',medium='',large=''):
	"Make the thumbnails from the make_thumb view"
	self.thumb_width = width
	self.thumb_height = height
         # first we do the thumbnails
        res = self.ask_4_thumbnails(self.thumbnails,prefix,width,height,recursive,double_name,remove,None)
        if(small == 'on'):
		if(not self.__dict__.has_key('small')):
			self.manage_addFolder('small',createPublic=0,createUserF=0,REQUEST=None)
		try:
			self.ask_4_thumbnails(self.small,prefix,320,320,recursive,double_name,remove,None)
		except:
			pass
		else:
			res = res + '<br> Small size created !'
			if('small' not in self.format_available):
				self.format_available.append('small')
	else: # we don't use the small size
		if('small' in self.format_available):
			self.format_available.remove('small')
			res = res + '<br> Small size removed !'
	if(medium == 'on'):
		if(not self.__dict__.has_key('medium')):
			self.manage_addFolder('medium',createPublic=0,createUserF=0,REQUEST=None)
		try:
			res = res + self.ask_4_thumbnails(self.medium,prefix,480,480,recursive,double_name,remove,None)
		except:
			pass
		else:
			res = res + '<br> Medium size created !'
			if('medium' not in self.format_available):
				self.format_available.append('medium')
	else: # we don't use the medium size
		if('medium' in self.format_available):
			self.format_available.remove('medium')
			res = res + '<br> Medium size removed !'
		
	if(large == 'on'):
		if(not self.__dict__.has_key('large')):
			self.manage_addFolder('large',createPublic=0,createUserF=0,REQUEST=None)
		try:
			self.ask_4_thumbnails(self.large,prefix,768,768,recursive,double_name,remove,None)
		except:
			pass
		else:
			res = res + '<br> Large size created !'
			if('large' not in self.format_available):
				self.format_available.append('large')
	else:
		if('large' in self.format_available):
			self.format_available.remove('large')
			res = res + '<br> Large size removed !'
	for elem in ['full','small','large','medium']:
		if(elem in self.format_available):
			self.default_photo_size = elem
	self.last_modif = DateTime()
	if(REQUEST!=None):		
		return self.make_thumb(REQUEST,manage_tabs_message=res)
	else:
		return res

    security.declareProtected('View management screen','ask_4_thumbnails')
    def ask_4_thumbnails(self,destination,prefix=None,width=200,height=200,recursive=None,double_name=None,remove=0,REQUEST=None):
        """Make the thumbnails   from the path"""
	info = ''
	if prefix == None: prefix = REQUEST.prefix
        if recursive == None: recursive = REQUEST.recursive # -> allow recursive in folder
        if double_name == None: double_name = REQUEST.double_name # able to manage photos with same name in different folder
        remove = int(remove)
	self.check_tmp_folder()
        if(remove):
     		for elem in destination.objectValues():
       			destination.manage_delObjects(elem.getId())
       	width = int(width)
	height = int(height)
	start_path = self.image_folder.basepath
	if(not self.__dict__.has_key('lib') or self.lib == 'PIL'):
		from photo_edition.IMG_start import *
		try:
			self.new_list_photo,amount = thumbnails_manage(start_path,self.tmp_dir,recursive,double_name,width,height,prefix,{})
	        except:
			print traceback.print_exc()
	else: # we use Image magick!
		from photo_edition.IMG_IM_start import *
		try:
			self.new_list_photo,amount = thumbnails_manage(start_path,self.convert,self.tmp_dir,recursive,double_name,width,height,prefix,{})
	        except:
			print traceback.print_exc()

	for elem in self.new_list_photo.keys():
		self.list_photo[elem] = self.new_list_photo[elem]
	infos = '<br>'
	for kei in self.list_photo.keys():
		tmp = self.list_photo[kei]
		if(type(tmp)=='' and tmp.find('Error') != -1):
			infos = infos + '<br>' + tmp
			del self.list_photo[kei]          
	result = ''
	if(self.list_photo != {}):
		result = ('<b>%i</b>'%amount) + ' '  + _('Thumbnails done in folder') + self.tmp_dir
#        if(upload==1):
	dict = {}
	dict,amount = self.upload_thumbnails(destination,prefix)
	result = result + ('<br><b>%i</b>'%amount) + ' ' +  _('Thumbnails uploaded in ZODB')
	if(dict != {}):
		for elem in dict.keys():
			result = result + _('<br><center><b><font color="red">Error in file upload in ZODB: [') + elem + ']:' +  dict[elem] + '</b></font></center>'
	self.remove_thumbnails_from_disk()
	if (infos != '<br>'):
		result = result + _('<br><center><b><font color="red">Error on files while creating thumbnails:') + infos + '</b></font></center>'
	self.get_nbr_non_hidden_thumb()
        if REQUEST is not None:
		return self.make_thumb(manage_tabs_message=result)
        else:
		return result
              
    security.declarePrivate('update_position')
    def update_position(self,new_position,old_position):
	for img in self.thumbnails.objectValues('Image'):
		if(img.position == new_position):
			img.position = old_position
				
    security.declareProtected('View management screen','update_photos_prop')
    def update_photos_prop(self,REQUEST):
        """update properties of the thumbnails"""
	list = []
	for elem in REQUEST.items():
		if elem[0].find('stringbidon') != -1:
			list.append(elem)
	dict = {}
	for elem in list:
		full = elem[0].split('/')
		id = full[1]
		property = full[2]
		value = elem[1]
		for img in self.thumbnails.objectValues('Image'):
	                if(img.getId()==id):
			   if property == 'removeit' and (value == '1'):
 					pos_del = img.position
					self.thumbnails.manage_delObjects(img.getId())
					for img in self.thumbnails.objectValues('Image'):
						if(img.position > pos_del):
							img.position = img.position - 1
			   else:
				   if property == 'keywords':
					keywords = value.split(',')
					list_keywords = []
					for keyword in keywords:
						keyword = keyword.strip()
						if(keyword!=''):
						   list_keywords.append(keyword)
					if(list_keywords != img.keywords):
						img.keywords = list_keywords
				   if property == 'title':
					if(img.title != value):
						img.title = value
				   if property == 'viewit':
					if(img.getviewit != value):
						img.getviewit = value # property has change
				   if property == 'position':
					old_position = img.position
					new_position = int(value)
					if(img.position != new_position):
						self.update_position(new_position,old_position)
						img.position = new_position
	string = ''
	self.get_nbr_non_hidden_thumb()
	self.thumbnails.amount_photo = self.get_thumb_amount()
	string = string[1:]
	result = _('Properties have been updated')
	return self.change_title(self,manage_tabs_message=result)

    security.declarePrivate('get_img_in_thumbnails')
    def get_img_in_thumbnails(self,img_id,list):
	for elem in list:
		if(elem.getId() == img_id):
			return elem
	return None

    security.declarePrivate('upload_file')
    def upload_file(self,tmpdir,cpt,img,destination):
	info = ''
	prop_id = 'getviewit'
	prop2_id = 'position'
	prop3_id = 'viewed'
	prop4_id = 'access' # way to access to the file
	prop5_id = 'way_to_access'
	prop6_id = 'keywords'
	file = open(tmpdir,'rb')
	data = file.read()
	file.close()
	cpt = self.get_thumb_amount()
	type = OFS.Image.getImageInfo(data)
	destination.manage_addImage(img,data,content_type=type[0])
	imag = getattr(destination,img)
	imag._setProperty(prop2_id.strip(),cpt,'int')
	cpt = cpt + 1
	imag._setProperty(prop5_id.strip(),'filesystem')
	imag._setProperty(prop4_id.strip(),self.list_photo[imag.getId()])
	imag._setProperty(prop_id.strip(), '1')
	imag._setProperty(prop3_id.strip(), 0,'int')
	imag._setProperty(prop6_id.strip(), [],'tokens')
	return cpt
	
    security.declareProtected('View management screen','upload_thumbnails')
    def upload_thumbnails(self,destination,prefix=None):
	"""Upload the thumbnails into the ZODB"""
	info = ''
	dict = {}
	cpt = 0
	if(prefix==None):
		prefix = self.thumb_prefix
	if(not self.__dict__.has_key('localfsver') or self.localfsver == "1.0"):
		for img in self.tmp.fileIds():
			if(img[:len(prefix)]==prefix and img[-3:]!='bak'):
				 # take thumbnails and bak files!
				 tmpdir = os.path.join(self.tmp_dir,img)
				 start_path = os.path.join(self.image_folder.basepath,img)
				 list = destination.objectValues()

				 image = self.get_img_in_thumbnails(img,list)
				 #check if the image isn't already in folder
				 imgobj = self.tmp._getOb(img)
				 if(image == None):
				 	try:
						cpt = self.upload_file(tmpdir,cpt,img,destination)
					except:
						info = _('Error: ')
						for i in sys.exc_info():
							info = info + '   ' + str(i)
						dict[img] = info
						print info

				 elif(imgobj.get_size() != image.getSize()):
				 	try:
						destination.manage_delObjects(img)
						cpt = self.upload_file(tmpdir,cpt,img,destination)
					except:
						info = _('Error: ')
						for i in sys.exc_info():
							info = info + '   ' + str(i)
						dict[img] = info
						print info
				 else:
				 	info = _('<font color="green"> Seems that the photo already exist in ZODB</font>')
				 	dict[img] = info
	else:
		for img in self.tmp.objectIds():
			if(img[:len(prefix)]==prefix and img[-3:]!='bak'):
				 # take thumbnails and bak files!
				 tmpdir = os.path.join(self.tmp_dir,img)
				 start_path = os.path.join(self.image_folder.basepath,img)
				 list = destination.objectValues()

				 image = self.get_img_in_thumbnails(img,list)
				 #check if the image isn't already in folder
				 imgobj = self.tmp._getOb(img)
				 if(image == None):
				 	try:
						cpt = self.upload_file(tmpdir,cpt,img,destination)
					except:
						info = _('Error: ')
						for i in sys.exc_info():
							info = info + '   ' + str(i)
						dict[img] = info
						print info

				 elif(imgobj.get_size() != image.getSize()):
				 	try:
						destination.manage_delObjects(img)
						cpt = self.upload_file(tmpdir,cpt,img,destination)
					except:
						info = _('Error: ')
						for i in sys.exc_info():
							info = info + '   ' + str(i)
						dict[img] = info
						print info
				 else:
				 	info = _('<font color="green"> Seems that the photo already exist in ZODB</font>')
				 	dict[img] = info
		
	list = destination.objectValues()
	if(list != [] and destination == self.thumbnails): #choose the first one for ZPhotoSlides Folder
		self.choose_symbolic_photo(list[0].getId())
	return dict,cpt

    security.declarePrivate('get_thumb_amount')
    def get_thumb_amount(self):
	return len(self.thumbnails.objectValues('Image'))

    security.declarePrivate('back_from_form')
    def back_from_form(self,REQUEST):
	text = ''
	for elem in REQUEST.form.keys():
		value = REQUEST.form[elem]
		if(value==''):
		   value='0'
		if(elem!='file'):
		   text = text + '<input type="hidden" name="%s" value="%s">' % (elem,value)
	return text
	
    security.declarePublic('view_preview')
    def view_preview(self,REQUEST):
	"""View the preview of an image"""
	img = self.image_modif(REQUEST,1)
	image = REQUEST.file
	self.check_tmp_folder()
	location = os.path.join(self.tmp_dir,img.imgname)
	img.save_to(location)
	hidden_part = self.back_from_form(REQUEST)
	msg2 = ''
	if(hasattr(REQUEST,'show_both') and REQUEST.show_both=='on'):
		msg2 = _('<table><tr><td class="boxborder"><center><h4>Before modification:</h4></center><br>') + '<img src="%s/img/%s?%d"></td>' % (REQUEST.URL1+'',image,random.randint(0,100))
        else:
                msg2 = ''
	return MessageDialog2(
		        title = _('Preview modification of') + image,
			message1 = _('<td class="boxborder"><center><h4>After modification: </h4></center><br><center>') + '<img src="%s/tmp/%s?%d"></center></td></tr></table>' % (REQUEST.URL1+'',img.imgname,random.randint(0,100)),
			message2 = msg2,
			hidden_field = hidden_part,
	  		action = 'edit_image',
			id = 'file',
			id_content = image,
			URL1 = REQUEST.URL1,
			actual_css = self.actual_css
			)
		
    security.declareProtected('View management screen','image_modif')
    def image_modif(self,REQUEST,preview=0):
        """Modify an image """
	image = REQUEST.file
        angle = REQUEST.angle
	path = self.image_folder.basepath
	abspath = path + '/' + image
	img = Image_modif(abspath)
        img.make_backup()
	modif = 0
	(img, modif) = img.modify_from_request(img,REQUEST)
	if(preview==1):
		return img
	if (modif==0):
		return self.edit_image(file=image,manage_tabs_message=_('Nothing has to be done on image') + image)
	img.save_modif()
	if REQUEST is not None:
		return self.edit_image(file=image,manage_tabs_message= _("Modification done for") + image)
    
    security.declareProtected('View management screen','get_image_info')
    def get_image_info(self,image_name):
	"""Get all the informations about an image"""
	path = self.image_folder.basepath
	abspath = os.path.join(path,image_name)
	img = Image_modif(abspath)
	dict = img.get_info()
	return dict

    security.declareProtected('View management screen','undo_modif')
    def undo_modif(self,REQUEST):
	"""Undo a previous modification of an image"""
	image = REQUEST.file
	bak = image + '.bak'
	path = self.image_folder.basepath
	new = os.path.join(path,image)
	backup = os.path.join(path,bak)
	if os.path.exists(backup):
	    shutil.copyfile(backup,new)
	    os.remove(backup)
	    return self.edit_image(file=image,manage_tabs_message=_("Undo successfull !"))
	else:
	    return self.edit_image(file=image,manage_tabs_message=_("Sorry, undo can't be done for this image."))
 
    security.declarePublic('viewable_images')               
    def viewable_images(self):
	images = self.thumbnails.objectValues('Image')
	for img in self.thumbnails.objectValues('Image'):
        	if(img.getviewit=='0'):
                	images.remove(img)
	images.sort(lambda x, y: cmp(x.position, y.position))
	return images

    security.declarePublic('encodemail')               
    def encodemail(self, emailvalue, namevalue):
        """ Encodage des emails """
        hs='0123456789ABCDEF'
        mystring='document.write(\'<a href=\"mailto:'+emailvalue+'\"><b>'+namevalue+'</b></a>\')'
        newstring=''

        length=len(mystring)
        for i in range(length):
           newstring=newstring+'%'+hs[int(floor((ord(mystring[i]))/16))]+hs[(ord(mystring[i]))%16]
      
        return '<script language=\"JavaScript\">eval(unescape(\''+newstring+'\'))</script>'

